﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XamDataTreeDynamicIconsCase
{
    public class ViewModel
    {
        public ObservableCollection<SampleData> Data { get; set; }

        string[] names = "Andrew;Alex;Jen;Steve;Murphy;Eric;Tom;Rich;Pamela".Split(';');

        public ViewModel()
        {
            Data = new ObservableCollection<SampleData>();

            for (int i = 0; i < names.Length; i++)
            {
                Data.Add(new SampleData()
                {
                    ID = i,
                    Name = names[i],
                    CollapsedImagePath = "Images/Arrow.png",
                    ExpandedImagePath = "Images/Arrow2.png"
                });
            }
        }
    }

    public class SampleData : INotifyPropertyChanged
    {
        public ObservableCollection<ChildData> Children { get; set; }

        private int _id;
        private string _name;
        private string _eip;
        private string _cip;

        public int ID
        {
            get { return _id; }
            set
            {
                if (_id != value)
                {
                    _id = value;
                    OnPropertyChanged("ID");
                }
            }
        }

        public string Name
        {
            get { return _name; }
            set
            {
                if (_name != value)
                {
                    _name = value;
                    OnPropertyChanged("Name");
                }
            }
        }

        public string ExpandedImagePath
        {
            get { return _eip; }
            set
            {
                if (_eip != value)
                {
                    _eip = value;
                    OnPropertyChanged("ExpandedImagePath");
                }
            }
        }

        public string CollapsedImagePath
        {
            get { return _cip; }
            set
            {
                if (_cip != value)
                {
                    _cip = value;
                    OnPropertyChanged("CollapsedImagePath");
                }
            }
        }

        public SampleData()
        {
            Children = new ObservableCollection<ChildData>();
            for (int i = 0; i < 2; i++)
            {
                Children.Add(new ChildData()
                {
                   Label = "Child Label " + i.ToString() 
                });
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;
        protected virtual void OnPropertyChanged(string propertyName)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(propertyName));
            }
        }
    }

    public class ChildData
    {        
        public string Label { get; set; }
    }
}
